/* Agent Library

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF
    
*/

#ifndef AGENT_LIB_H
#define AGENT_LIB_H

// }N֐Fbit check macro
#define BIT_CHECK(BYTE, BIT_NO)         (((BYTE)>>(BIT_NO)) & 0x01)

// WDT ݒp
#define _WDT_CHANGE         ((1<<WDCE) | (1<<WDE))                              // WDT ݒύXiFύXO̕K{j
#define _WDT_DISABLE        ((0<<WDIE) | (0<<WDE))                              // WDT DISABLE
#define _WDT_INTERRUPT      ((1<<WDIE) | (0<<WDE))                              // WDT INTERRUPT MODE
#define _WDT_RESET          ((0<<WDIE) | (1<<WDE))                              // WDT SYSTEM RESET MODE
#define _WDT_INT_RESET      ((1<<WDIE) | (1<<WDE))                              // WDT INTERRUPT & SYSTEM RESET MODE
#define RESET_WDT           __asm__ __volatile__ ("wdr")                        // WDT RESET ߃}N

// WDT Prescaler * 128kHz Oscillator
#define _WDT_16MS           ((0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER    2K CYCLE  16ms
#define _WDT_32MS           ((0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER    4K CYCLE  32ms
#define _WDT_64MS           ((0<<WDP3) | (0<<WDP2) | (1<<WDP1) | (0<<WDP0))     // PRESCALER    8K CYCLE  64ms
#define _WDT_125MS          ((0<<WDP3) | (0<<WDP2) | (1<<WDP1) | (1<<WDP0))     // PRESCALER   16K CYCLE 125ms
#define _WDT_250MS          ((0<<WDP3) | (1<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER   32K CYCLE 250ms
#define _WDT_500MS          ((0<<WDP3) | (1<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER   64K CYCLE 500ms
#define _WDT_1S             ((0<<WDP3) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0))     // PRESCALER  128K CYCLE  1.0s
#define _WDT_2S             ((0<<WDP3) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0))     // PRESCALER  256K CYCLE  2.0s
#define _WDT_4S             ((1<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER  512K CYCLE  4.0s
#define _WDT_8S             ((1<<WDP3) | (0<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER 1024K CYCLE  8.0s

// Y\[X
enum RHYTHM_SOURCE {
    SWITCH_TRG                                                                  // XCb`ɂgK
,   TIMER_TRG                                                                   // ^C}[ɂgK(WDT)
};
#define DEFAULT_RHYTHM_SOURCE   SWITCH_TRG                                      // ftHg̃Y\[X

// ̑
#define NA_VAL              0                                                   // ȂǁClɈӖȂꍇɎgp

// f[^t[\
enum DATA_FRAME {
    ACT                                                                         // ACTR[h
,   ACT_REV                                                                     // `i]R[hj
,   FRAME_SIZE                                                                  // t[TCYizTCYjmӁñV{͔z錾łȂCt[`ɂgp
};

// t[̃oCgi[Xe[^XGadd_byte_frameɐݒ肷
enum FRAME_SIZE_STATUS {
    FRAME_INI              =0                                                   // t[擾̏l
,   FRAME_SHORT                                                                 // F܂ǉ\.
,   FRAME_FULL                                                                  // F傤ǖt
,   FRAME_OVER                                                                  // t[TCY
};

// \̐錾
typedef struct Struct_frame {                                                   // t[\́F
    uint8_t data[FRAME_SIZE];                                                   // t[{́iBytezj
    uint8_t status;                                                             // oCgi[Xe[^XGadd_byte_frame()̃Xe[^X
    uint8_t pos_rd;                                                             // oCgǎʒu
    uint8_t pos_wr;                                                             // oCgʒu
} Frame;

typedef struct Struct_Act {                                                     // ACT\́F
    uint8_t act;                                                                // ACTp^
} Act;

// vg^Cv錾
Act* get_act(void);                                                             // ACT擾
void add_byte_frame(Frame*, uint8_t);                                           // oCgt[Ɋi[
Frame* make_frame(Act*, Frame*);                                                // f[^t[
#endif
