/* Agent Library Common

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF

*/

#include <avr/io.h>
#include <avr/eeprom.h>

#include "actuate.h"
#include "agent_lib.h"
#include "ir_transmit.h"
#include "ir_receive.h"

extern uint8_t act_num;                                                         // AN`G[^o͎ ACTnum
extern uint8_t bitassign[];                                                     // o̓rbgATCe[uiEEPROMj
extern uint8_t convassign[];                                                    // o̓rbgATCe[uiRAMj

// jbgݒ
void init_unit(void) {

    // ACTnumݒFACT0/ACT2/ACT4/ACT6/ACT8
    // ̗ł͂U|[go͂ɐݒ肵܂GmIWinjbg I2CƓł
    act_num = ACT6;
    
    //|[gFSďo͐ݒ肵Ă܂
    DDRA  = 0b11111111;                                                         // 8bit
    PORTA = 0;
    DDRB  = 0b00001111;                                                         // 4bit
    PORTB = 0;
    
    // XCb`͐ݒ
    DDRB &= ~(1<<PB1);                                                          // PB1 (PCINT9) ͐ݒ
    PORTB |= (1<<PB1);                                                          // PB1 vAbv
    
    // XCb`ݒ
    PCMSK1 |= (1<<PCINT9) ;                                                     // PB1iPCINT9jL
    GIMSK |= (1<<PCIE1);                                                        // PCINT9 L

    // o̓rbgATCe[u擾
    eeprom_busy_wait();
    eeprom_read_block(convassign, bitassign, 8);
    
    // WDT 
    MCUSR &= ~(1<<WDRF);                                                        // Watchdog Reset Flag     
    RESET_WDT;                                                                  // WDT Zbg    wdt_reset();
    WDTCSR |= _WDT_CHANGE;                                                      // WDT ݒύXiFύXO̕K{j
    WDTCSR = 0x00;                                                              // WDT ~
    
    
    //yz^C}O IRM/Mŋp܂Iydlz
    
    // ***** IRM̐ݒ *****
    
    // |[gݒFIRo͗p
    // OC0Bo̓sɌ悤ɂĂ
    
    // ^C}ݒi^C}OjF38kHzpXp
    pulse38off();                                                               // IRpXU~i^C}O~j
    
    // ^C}ݒi^C}PFm[}[hjFIRR[hp
    TCCR1A = 0x00;                                                              // 0000 0000 OC1xڑCm[}[h
    TCCR1B = 0x00;                                                              // ^C}PJEg~ino-clockj
    TCNT1 = 0;                                                                  // JE^OZbg
    TIMSK1 &= ~(1<<TOIE1);                                                      // TOIE1 
    
    // ***** IRM̐ݒ *****
    
    // ̓|[gݒFIRMiIRW[j
    INT0_IR_DDR &= ~(1<<INT0_IR_BIT);                                           // INT0 IRMs͐ݒ
    INT0_IR_PORT |= (1<<INT0_IR_BIT);                                           // INT0 IRMsvAbvFW[OꍇȂǁĈ͈
    
    init_ir_receiver(IR_RECEIVER_ON);                                           // IRMݒiIRM̗Lj
}
