/* Agent IR Receivver Library

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF
    
*/

#ifndef IR_TRANSMITTER_H
#define IR_TRANSMITTER_H

// IR 38KHzpXpf[eB1:3̃pXݒi8MHzNbNF8bit ^C}j
#define IR_ON_PERIOD            70                                              // ON=8.7usipXj
#define IR_PULSE_PERIOD         210                                             // pX=26.3usGOFF=17.6usiS̎26.3us-pX8.7usj

// R[ho͂̎ݒi8MHzNbNF16bit ^C}j
// FW[̏o͎600usɍ킹ĔMR[h̏o͎600us̔{ɐݒ

// OR[hpiH1:L1v1.2msj
#define ZERO_H                  4800
#define ZERO_L                  4800

// PR[hpiH1:L2v1.8msj
#define ONE_H                   4800
#define ONE_L                   9600

// STARTR[hpiH5:L1v3.6msj
#define START_H                 24000
#define START_L                 4800

// STOPR[hpiH1:L5v3.6msj
#define STOP_H                  4800
#define STOP_L                  24000

// IRt[MGMXebv
enum IR_TRANS_STEP {
    IR_START                    =0                                              // IRt[̊JnR[h
,   IR_BIT0                     =1
,   IR_BIT1                     =2
,   IR_BIT2                     =3
,   IR_BIT3                     =4
,   IR_BIT4                     =5
,   IR_BIT5                     =6
,   IR_BIT6                     =7
,   IR_BIT7                     =8
,   IR_STOP                     =9                                              // f[^oCg̏IR[h / IRt[̏IR[h
,   TRANSMIT_COMPLETE           =0xFF                                           // oCg̑MXe[^X
};

// IRR[ho̓V[PXGIRR[h @gR[hƇAkR[h̑gō\GQ ircode_out() ֐
enum IR_SEQUENCE {
    H_SEQ
,   L_SEQ
};

// 38kHzpX
enum PULSE38_OPERATION {
    PULSE38_OFF
,   PULSE38_ON
};

// vg^Cv錾
void ir_transmit(Frame*);                                                       // IRM
void irtrans_operation(uint8_t, uint8_t);                                       // IR`i^C}n`IRM҂`^C}~jmPnJnXebvmQnMoCg
void irtrans_seq(void);                                                         // IR`V[PXitH[}bgj
void ircode_out(unsigned int, unsigned int);                                    // IRR[hómPngo͕mQnko͕
void pulse38on(void);                                                           // IRpX: 38kHzpXUJn
void pulse38off(void);                                                          // IRpX: 38kHzpXU~
#endif
